## libapache2-mod-rivet 3.1.1

=== cmake/CMakeLists.txt ===
# Georgios Petasis, petasis@iit.demokritos.gr

# The minimum version of cmake required. This may work also in 2.8,
# but I have not tested. My cmake is version 3.9.0.
cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

# Rivet version:
# In order to avoid chasing around multiple definition of the module version we infer
# this information from the file VERSION, which must stay in the project root directory
# and assuming we are working from a direct child directory
SET ( RIVET_TOP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/.." )
# Read the file named VERSION from the top Rivet directory...
FILE ( READ "${RIVET_TOP_DIR}/VERSION" RIVET_VERSION_FROM_FILE )
STRING ( REGEX MATCH "([0-9]+)\.([0-9]+)\.([0-9]+)" _ ${RIVET_VERSION_FROM_FILE} )
SET ( RIVET_MAJOR_VERSION ${CMAKE_MATCH_1} )
SET ( RIVET_MINOR_VERSION ${CMAKE_MATCH_2} )
SET ( RIVET_PATCH_VERSION ${CMAKE_MATCH_3} )
MESSAGE ( STATUS "Rivet version: ${RIVET_MAJOR_VERSION}.${RIVET_MINOR_VERSION}.${RIVET_PATCH_VERSION}" )

set(RIVET_VERSION
  ${RIVET_MAJOR_VERSION}.${RIVET_MINOR_VERSION}.${RIVET_PATCH_VERSION})
set(INIT_VERSION ${RIVET_MAJOR_VERSION}.${RIVET_MINOR_VERSION})

# Rivetlib version:
set(RIVETLIB_PACKAGE "rivetlib")
set(RIVETLIB_PACKAGE_VERSION ${INIT_VERSION})

# The arguments argument are optional, declares version and language
# (in this case C).
project(Rivet VERSION ${RIVET_VERSION} LANGUAGES C)

#  User options...
# ===========================================================================
set(with-tclsh "" CACHE FILEPATH "location of a working tclsh executable")
set(with-tcl   "" CACHE PATH "directory containing tcl configuration (tclConfig.sh)")
set(with-post-max 0 CACHE STRING  "BYTES Maximum size of data to be sent with a POST")
set(with-rivet-core "mod_rivet_ng" CACHE STRING "mod_rivet core directory")
set(with-upload-dir "/tmp"         CACHE STRING "Default directory for uploads")
option(version-display            "Display Rivet version in Apache signature" OFF)
option(head-requests              "Returns real headers in response to a HEAD request" OFF)
option(single-thread              "forces the worker brigde to create a single thread (debug)" OFF)
option(rivet-commands-export      "prevent export from ::rivet namespace" ON)
option(import-rivet-commands      "requires explicit namespace import" OFF)
option(virtual-interps-separation "to turn on virtual host separation" OFF)
option(requests-serialization     "Forces HTTP requests serialization among threads(debug)" OFF)
option(upload-var                 "whether files are uploaded to Tcl variables" ON)
option(BUILD_SHARED_LIBS          "build and link with shared libraries" ON)
option(TCL_THREADS                "build with threads" ON)
option(TCL_MEM_DEBUG              "build with memory debugging" OFF)

include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(BUILD_STATIC_LIBS "build as static library" ON
                       "NOT BUILD_SHARED_LIBS" OFF)

# Offer the user the choice of overriding the installation directories
set(INSTALL_LIB_DIR lib CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR bin CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR include CACHE PATH
  "Installation directory for header files")
if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR CMake)
else()
  set(DEF_INSTALL_CMAKE_DIR lib/CMake/Rivet)
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH
  "Installation directory for CMake files")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

# Use GNU install directories
include(GNUInstallDirs)

#  Rivet source files...
# ===========================================================================
set(RIVET_SRC_DIR "${PROJECT_SOURCE_DIR}/../src")
set(RIVET_LIB_DIR "${PROJECT_SOURCE_DIR}/../rivet")
set(RIVET_CORE ${with-rivet-core})

set(rivetparser_sources
  ${RIVET_SRC_DIR}/parser/rivetParser.c
  ${RIVET_SRC_DIR}/parser/parserPkgInit.c
)

set(rivetlib_sources
  ${RIVET_SRC_DIR}/librivet/rivetList.c
  ${RIVET_SRC_DIR}/librivet/rivetCrypt.c
  ${RIVET_SRC_DIR}/librivet/rivetWWW.c
  ${RIVET_SRC_DIR}/librivet/rivetPkgInit.c
)

set(rivet_worker_mpm_sources
  ${RIVET_SRC_DIR}/${RIVET_CORE}/rivet_worker_mpm.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/worker_prefork_common.c
)

set(rivet_prefork_mpm_sources
  ${RIVET_SRC_DIR}/${RIVET_CORE}/rivet_prefork_mpm.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/worker_prefork_common.c
)

set(rivet_lazy_mpm_sources
  ${RIVET_SRC_DIR}/${RIVET_CORE}/rivet_lazy_mpm.c
)

set(mod_rivet_sources
  ${RIVET_SRC_DIR}/${RIVET_CORE}/mod_rivet.c
  ${RIVET_SRC_DIR}/request/apache_multipart_buffer.c
  ${RIVET_SRC_DIR}/request/apache_request.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/rivetCore.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/rivetInspect.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/rivetChannel.c
  ${RIVET_SRC_DIR}/parser/rivetParser.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/TclWebapache.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/apache_config.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/mod_rivet_cache.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/mod_rivet_common.c
  ${RIVET_SRC_DIR}/${RIVET_CORE}/mod_rivet_generator.c
)

#  Add build targets...
# ===========================================================================
add_library(mod_rivet            SHARED ${mod_rivet_sources})
add_library(rivetparser          SHARED ${rivetparser_sources})
add_library(rivetlib             SHARED ${rivetlib_sources})
add_library(rivet_worker_mpm     SHARED ${rivet_worker_mpm_sources})
add_library(rivet_prefork_mpm    SHARED ${rivet_prefork_mpm_sources})
add_library(rivet_lazy_mpm       SHARED ${rivet_lazy_mpm_sources})
add_library(rivet::parser        ALIAS rivetparser)
add_library(rivet::lib           ALIAS rivetparser)
add_library(rivet::rivet         ALIAS mod_rivet)
add_library(rivet::worker_mpm    ALIAS rivet_worker_mpm)
add_library(rivet::prefork_mpm   ALIAS rivet_prefork_mpm)
add_library(rivet::lazy_mpm      ALIAS rivet_lazy_mpm)

SET ( RIVET_LIB_SUFFIX ".so" )
SET ( RIVET_LIB_PREFIX "lib" )

SET_TARGET_PROPERTIES(mod_rivet         PROPERTIES PREFIX "" SUFFIX ${RIVET_LIB_SUFFIX})
SET_TARGET_PROPERTIES(rivet_worker_mpm  PROPERTIES PREFIX "" SUFFIX ${RIVET_LIB_SUFFIX})
SET_TARGET_PROPERTIES(rivet_prefork_mpm PROPERTIES PREFIX "" SUFFIX ${RIVET_LIB_SUFFIX})
SET_TARGET_PROPERTIES(rivet_lazy_mpm    PROPERTIES PREFIX "" SUFFIX ${RIVET_LIB_SUFFIX})
SET_TARGET_PROPERTIES(rivetparser       PROPERTIES PREFIX ${RIVET_LIB_PREFIX})
SET_TARGET_PROPERTIES(rivetlib          PROPERTIES PREFIX ${RIVET_LIB_PREFIX})

#  Definitions...
# ===========================================================================
target_compile_definitions (rivetparser        PRIVATE
   HAVE_CONFIG_H=1 USE_TCL_STUBS=1 START_TAG="<?" END_TAG="?>" )
target_compile_definitions (rivetlib           PRIVATE
   HAVE_CONFIG_H=1 USE_TCL_STUBS=1 START_TAG="<?" END_TAG="?>" )
target_compile_definitions (rivet_worker_mpm   PRIVATE HAVE_CONFIG_H=1 )
target_compile_definitions (rivet_prefork_mpm  PRIVATE HAVE_CONFIG_H=1 )
target_compile_definitions (rivet_lazy_mpm     PRIVATE HAVE_CONFIG_H=1 )
target_compile_definitions (mod_rivet          PRIVATE
   HAVE_CONFIG_H=1 START_TAG="<?" END_TAG="?>" )

# ===========================================================================
#  Locate needed packages...
# ===========================================================================
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake_extra_modules")
include(checks)

#  Locate Tcl...
# ===========================================================================
MESSAGE ( STATUS "Searching for Tcl..." )
if (NOT "${with-tcl}" STREQUAL "")
  MESSAGE ( STATUS "  Tcl lib directory manually set by -Dwith-tcl=" ${with-tcl} )
  get_filename_component(RIVET_TCL_ROOT "${with-tcl}" DIRECTORY)
  MESSAGE ( STATUS "  Setting Tcl root to: " ${RIVET_TCL_ROOT} )
  set ( CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${RIVET_TCL_ROOT} )
  set (TCL_ROOT ${RIVET_TCL_ROOT})
  set (TclStub_ROOT ${RIVET_TCL_ROOT})
endif ()
if (NOT "${with-tclsh}" STREQUAL "")
  MESSAGE ( STATUS "  Tclsh manually set by -Dwith-tclsh=" ${with-tclsh} )
  set (TCL_TCLSH ${with-tclsh})
endif ()
FIND_PACKAGE ( TCL 8.5.10 REQUIRED )
FIND_PACKAGE ( TclStub 8.5.10 REQUIRED )
MESSAGE ( STATUS "  TCL_TCLSH:               " ${TCL_TCLSH} )
MESSAGE ( STATUS "  TCL_INCLUDE_PATH:        " ${TCL_INCLUDE_PATH} )
MESSAGE ( STATUS "  TCL_LIBRARY:             " ${TCL_LIBRARY} )
MESSAGE ( STATUS "  TCL_STUB_LIBRARY:        " ${TCL_STUB_LIBRARY} )

#  Locate Apache...
# ===========================================================================
MESSAGE ( STATUS "Searching for Apache..." )

if (NOT "${with-apache}" STREQUAL "")
  MESSAGE ( STATUS "  Apache directory manually set by -Dwith-apache=" ${with-apache} )
  get_filename_component(RIVET_APACHE_ROOT "${with-apache}" ABSOLUTE)
  MESSAGE ( STATUS "  Setting Apache root to: " ${RIVET_APACHE_ROOT} )

  set ( APACHE_ROOT ${RIVET_APACHE_ROOT} )
  set ( APACHE_MODULE_DIR "${RIVET_APACHE_ROOT}/modules" )
  set ( APACHE_LIB_DIR "${RIVET_APACHE_ROOT}/lib" )
  set ( TclStub_ROOT ${RIVET_APACHE_ROOT})

endif ()

find_package(APACHE REQUIRED)
MESSAGE ( STATUS "  APACHE_INCLUDE_DIR:      " ${APACHE_INCLUDE_DIR} )
MESSAGE ( STATUS "  APACHE_MODULE_DIR:       " ${APACHE_MODULE_DIR} )
MESSAGE ( STATUS "  APACHE_LIB_DIR:          " ${APACHE_LIB_DIR} )

#  Locate Apr...
# ===========================================================================
MESSAGE ( STATUS "Searching for Apr..." )
find_package(APR REQUIRED)
MESSAGE ( STATUS "  APR_INCLUDE_DIR:         " ${APR_INCLUDE_DIR} )
MESSAGE ( STATUS "  APR_LIBRARY:             " ${APR_LIBRARY} )
MESSAGE ( STATUS "  APRUTIL_INCLUDE_DIR:     " ${APRUTIL_INCLUDE_DIR} )
MESSAGE ( STATUS "  APRUTIL_LIBRARY:         " ${APRUTIL_LIBRARY} )

find_package(Threads)

#  Set up include directories...
# ===========================================================================
set(RIVET_GENERATE_DIR ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
set(RIVET_GENERATE_DIR ${PROJECT_BINARY_DIR}/generated)
set(RIVET_INCLUDE_DIRS_PUBLIC
  "${TCL_INCLUDE_PATH}"
  "${APACHE_INCLUDE_DIR}"
  "${APR_INCLUDE_DIR}"
  "${APRUTIL_INCLUDE_DIR}"
)
set(RIVET_INCLUDE_DIRS_PRIVATE
  "${RIVET_SRC_DIR}"
  "${RIVET_SRC_DIR}/${RIVET_CORE}"
  "${RIVET_SRC_DIR}/parser"
  "${RIVET_SRC_DIR}/request"
  "${RIVET_GENERATE_DIR}"
  "${PROJECT_BINARY_DIR}" 
)

target_include_directories(rivetparser
  PUBLIC ${RIVET_INCLUDE_DIRS_PUBLIC} PRIVATE ${RIVET_INCLUDE_DIRS_PRIVATE})
target_include_directories(rivetlib
  PUBLIC ${RIVET_INCLUDE_DIRS_PUBLIC} PRIVATE ${RIVET_INCLUDE_DIRS_PRIVATE})
target_include_directories(rivet_worker_mpm
  PUBLIC ${RIVET_INCLUDE_DIRS_PUBLIC} PRIVATE ${RIVET_INCLUDE_DIRS_PRIVATE})
target_include_directories(rivet_prefork_mpm
  PUBLIC ${RIVET_INCLUDE_DIRS_PUBLIC} PRIVATE ${RIVET_INCLUDE_DIRS_PRIVATE})
target_include_directories(rivet_lazy_mpm
  PUBLIC ${RIVET_INCLUDE_DIRS_PUBLIC} PRIVATE ${RIVET_INCLUDE_DIRS_PRIVATE})
target_include_directories(mod_rivet
  PUBLIC ${RIVET_INCLUDE_DIRS_PUBLIC} PRIVATE ${RIVET_INCLUDE_DIRS_PRIVATE})

#  Set up libraries...
# ===========================================================================
target_link_libraries(rivetparser        ${TCL_STUB_LIBRARY})
target_link_libraries(rivetlib           ${TCL_STUB_LIBRARY})
target_link_libraries(mod_rivet          ${TCL_LIBRARY})
if(WIN32)
  # Under Windows, we need to link with all libraries, even libhttpd.lib
  MESSAGE ( STATUS "Searching for libhttpd.lib (Windows)..." )
  FIND_LIBRARY(APACHE_HTTPD_LIBRARY libhttpd libhttpd.lib
    NAMES ${APACHE_HTTPD_NAMES}
    PATHS ${APACHE_HTTPD_LIBRARY_HINTS}
          ${APACHE_ROOT}/lib
  )
  MESSAGE ( STATUS "  APACHE_HTTPD_LIBRARY:    " ${APACHE_HTTPD_LIBRARY} )

  # Export all symbols from mod_rivet
  #SET_TARGET_PROPERTIES(mod_rivet PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

  target_link_libraries(mod_rivet          ${APR_LIBRARY} ${APACHE_HTTPD_LIBRARY} )

=== debian/changelog ===
libapache2-mod-rivet (3.1.1-1) unstable; urgency=medium

  * New upstream release 
  * Add missing copyright references
  * Checked 4.3.0 standards 

 -- Massimo Manghi <mxmanghi@apache.org>  Sun, 13 Jan 2019 16:42:32 +0100

libapache2-mod-rivet (3.1.0-1) unstable; urgency=medium

  * New upstream release 

 -- Massimo Manghi <mxmanghi@apache.org>  Thu, 29 Nov 2018 23:15:17 +0100

libapache2-mod-rivet (3.0.2-3) unstable; urgency=medium

  * Depending on tcl-itcl4 as an alternative for the Itcl OO extension

 -- Massimo Manghi <mxmanghi@apache.org>  Mon, 29 Oct 2018 23:43:48 +0100

libapache2-mod-rivet (3.0.2-2) unstable; urgency=medium

  * Problem with changelog.Debian fixed as demanded by lintian
  * Moving SQL code and examples in rivet/packages to their destination
    in /usr/share/doc
  * Removed from 'rules' now unneded installation file handling as 
    everything is supposed to be properly done in the patched Makefile.am
  * Now compliant with the new standards version 

 -- Massimo Manghi <mxmanghi@apache.org>  Tue, 18 Sep 2018 23:32:38 +0200

=== debian/control ===
Source: libapache2-mod-rivet
Section: httpd
Priority: optional
Maintainer: Massimo Manghi <mxmanghi@apache.org>
Build-Depends: tcl-dev, apache2-dev, libtool, debhelper (>= 11~), automake, dpkg-dev (>= 1.16.1~) 
Standards-Version: 4.3.0
Homepage: http://tcl.apache.org/rivet/

Package: libapache2-mod-rivet
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tcl-itcl4 | itcl3, tcllib
Suggests: libapache2-mod-rivet-doc
Description: Server-side Tcl programming system combining ease of use and power
 Apache Rivet is a system for creating dynamic web content via the Tcl
 programming language integrated with Apache Web Server. It is
 designed to be fast, powerful and extensible, consume few system
 resources, be easy to learn, and to provide the user with a platform
 that can also be used for other programming tasks outside the web
 (GUI's, system administration tasks, text processing, database
 manipulation, XML, and so on). In order to meet these goals
 Tcl programming language was chosen to combine with the Apache HTTP
 Server.

Package: libapache2-mod-rivet-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Documentation for Rivet, a server-side Tcl programming system 
 Apache Rivet is a system for creating dynamic web content via the Tcl
 programming language integrated with Apache Web Server. It is
 designed to be fast, powerful and extensible, consume few system
 resources, be easy to learn, and to provide the user with a platform
 that can also be used for other programming tasks outside the web
 (GUI's, system administration tasks, text processing, database
 manipulation, XML, and so on). In order to meet these goals
 Tcl programming language was chosen to combine with the Apache HTTP
 Server. This package contains the HTML configuration and programming manual.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

TCL_VERSION=8.6
package=libapache2-mod-rivet
RIVETLIB_DIR=/usr/lib/tcltk/rivet3.1
TCLSH_PROG=/usr/bin/tclsh

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Don't let the configure script guess our platform.
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O2
endif

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	rm -f _configs.sed
	dh_auto_clean
	dh_clean

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp: configure-stamp
	dh_testdir
	$(MAKE)
	touch build-stamp

configure-stamp:
	dh_testdir
	dh_autoreconf_clean
	dh_autoreconf
	chmod +x ./configure
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"         \
	./configure --host=$(DEB_HOST_GNU_TYPE)         \
		    --build=$(DEB_BUILD_GNU_TYPE)           \
		    --with-tcl=/usr/lib/                    \
		    --with-apache=/usr                      \
		    --with-apxs=/usr/bin/apxs               \
		    --with-tclsh=$(TCLSH_PROG)              \
		    --with-rivet-target-dir=$(RIVETLIB_DIR) \
		    --enable-version-display 
	touch configure-stamp

binary-indep: build libapache2-mod-rivet-doc

binary-arch: build libapache2-mod-rivet

binary: build binary-arch binary-indep

libapache2-mod-rivet: build
	dh_testdir -a 
	dh_testroot -a 
	dh_clean
	dh_installdirs -p$@
	dh_installchangelogs ChangeLog
	dh_installdocs -p$@
	dh_install -a
	dh_apache2 
	dh_installexamples -a -p$@
	dh_auto_install -a -p$@ --destdir=$(CURDIR)/debian/$@
	# Remove README* files in bogus places.
	#@echo "removing unwanted README and .la files"
	#find $(CURDIR)/debian/$@/usr/lib/tcltk -name 'README*' -exec rm -v {} \;
	#find $(CURDIR)/debian/$@/usr/lib/tcltk -name '*.la' -exec rm -v {} \;
	dh_install -a -p$@
	#cp -vr rivet/packages $(CURDIR)/debian/$@$(RIVETLIB_DIR)
	#@echo "creating pkgIndex.tcl files for libapache2-mod-rivet"
	#find $(CURDIR)/debian/$@$(RIVETLIB_DIR) -name 'pkgIndex.tcl' -exec rm -v {} \;
	#-(  cd $(CURDIR)/debian/$@$(RIVETLIB_DIR); \
	#    echo 'eval pkg_mkIndex -verbose [pwd] [glob init.tcl [file join packages * *.tcl] [file join *[info sharedlibextension]]]' | $(TCLSH_PROG) ; )
	dh_installman -p$@
	dh_link -p$@
	dh_strip -p$@
	dh_compress -p$@
	dh_fixperms -p$@
	dh_makeshlibs -p$@
	dh_installdeb -p$@
	dh_shlibdeps -p$@
	dh_gencontrol -p$@
	dh_md5sums -p$@
	dh_builddeb -p$@ 

libapache2-mod-rivet-doc: build
	dh_testdir
	dh_testroot
	dh_installdirs -p$@
	dh_installchangelogs ChangeLog
	dh_installdocs -p$@ --exclude=Rivetlogo_small.png
	#find $(CURDIR)/debian/$@/usr/share/doc/libapache2-mod-rivet-doc/html/images/ -name 'Rivetlogo_small.png' -exec rm -v {} \;
	dh_compress -p$@
	dh_fixperms -p$@
	dh_installdeb -p$@
	dh_gencontrol -p$@
	dh_md5sums -p$@
	dh_builddeb -p$@ 

.PHONY: build clean binary binary-indep binary-arch

## libapache2-mod-rivet 3.2.0

=== debian/changelog ===
libapache2-mod-rivet (3.2.0-1) unstable; urgency=medium

  * New upstream release 
  * Validated standards compliance up to 4.5.0

 -- Massimo Manghi <mxmanghi@apache.org>  Mon, 09 Nov 2020 09:28:09 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Massimo Manghi <mxmanghi@apache.org>
 Build-Depends: tcl-dev, apache2-dev, libtool, debhelper (>= 11~), automake, dpkg-dev (>= 1.16.1~) 
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: http://tcl.apache.org/rivet/
 
 Package: libapache2-mod-rivet

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://www.apache.org/dist/tcl/rivet/rivet-(\d.*)\.tar\.gz

## libapache2-mod-rivet 3.2.1

=== cmake/CMakeLists.txt ===
--- 
+++ 
@@ -124,12 +124,12 @@
 
 #  Add build targets...
 # ===========================================================================
-add_library(mod_rivet            SHARED ${mod_rivet_sources})
-add_library(rivetparser          SHARED ${rivetparser_sources})
-add_library(rivetlib             SHARED ${rivetlib_sources})
-add_library(rivet_worker_mpm     SHARED ${rivet_worker_mpm_sources})
-add_library(rivet_prefork_mpm    SHARED ${rivet_prefork_mpm_sources})
-add_library(rivet_lazy_mpm       SHARED ${rivet_lazy_mpm_sources})
+add_library(mod_rivet            ${mod_rivet_sources})
+add_library(rivetparser          ${rivetparser_sources})
+add_library(rivetlib             ${rivetlib_sources})
+add_library(rivet_worker_mpm     ${rivet_worker_mpm_sources})
+add_library(rivet_prefork_mpm    ${rivet_prefork_mpm_sources})
+add_library(rivet_lazy_mpm       ${rivet_lazy_mpm_sources})
 add_library(rivet::parser        ALIAS rivetparser)
 add_library(rivet::lib           ALIAS rivetparser)
 add_library(rivet::rivet         ALIAS mod_rivet)
@@ -180,8 +180,8 @@
   MESSAGE ( STATUS "  Tclsh manually set by -Dwith-tclsh=" ${with-tclsh} )
   set (TCL_TCLSH ${with-tclsh})
 endif ()
-FIND_PACKAGE ( TCL 8.5.10 REQUIRED )
-FIND_PACKAGE ( TclStub 8.5.10 REQUIRED )
+FIND_PACKAGE ( TCL 8.6.1 REQUIRED )
+FIND_PACKAGE ( TclStub 8.6.1 REQUIRED )
 MESSAGE ( STATUS "  TCL_TCLSH:               " ${TCL_TCLSH} )
 MESSAGE ( STATUS "  TCL_INCLUDE_PATH:        " ${TCL_INCLUDE_PATH} )
 MESSAGE ( STATUS "  TCL_LIBRARY:             " ${TCL_LIBRARY} )
@@ -190,19 +190,6 @@
 #  Locate Apache...
 # ===========================================================================
 MESSAGE ( STATUS "Searching for Apache..." )
-
-if (NOT "${with-apache}" STREQUAL "")
-  MESSAGE ( STATUS "  Apache directory manually set by -Dwith-apache=" ${with-apache} )
-  get_filename_component(RIVET_APACHE_ROOT "${with-apache}" ABSOLUTE)
-  MESSAGE ( STATUS "  Setting Apache root to: " ${RIVET_APACHE_ROOT} )
-
-  set ( APACHE_ROOT ${RIVET_APACHE_ROOT} )
-  set ( APACHE_MODULE_DIR "${RIVET_APACHE_ROOT}/modules" )
-  set ( APACHE_LIB_DIR "${RIVET_APACHE_ROOT}/lib" )
-  set ( TclStub_ROOT ${RIVET_APACHE_ROOT})
-
-endif ()
-
 find_package(APACHE REQUIRED)
 MESSAGE ( STATUS "  APACHE_INCLUDE_DIR:      " ${APACHE_INCLUDE_DIR} )
 MESSAGE ( STATUS "  APACHE_MODULE_DIR:       " ${APACHE_MODULE_DIR} )
@@ -270,3 +257,10 @@
   #SET_TARGET_PROPERTIES(mod_rivet PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
 
   target_link_libraries(mod_rivet          ${APR_LIBRARY} ${APACHE_HTTPD_LIBRARY} )
+  target_link_libraries(rivet_worker_mpm   ${APR_LIBRARY} ${APRUTIL_LIBRARY} ${APACHE_HTTPD_LIBRARY} mod_rivet)
+  target_link_libraries(rivet_prefork_mpm  ${APR_LIBRARY} ${APACHE_HTTPD_LIBRARY} mod_rivet)
+  target_link_libraries(rivet_lazy_mpm     ${APR_LIBRARY} ${APACHE_HTTPD_LIBRARY} mod_rivet)
+  # rivet_worker_mpm.c uses round(), which is available in C99
+  SET_TARGET_PROPERTIES(rivet_worker_mpm PROPERTIES C_STANDARD 99)
+  if(MSVC)
+    # Libraries linked with tclstubs.lib library, cannot use /SAFESEH

=== debian/changelog ===
libapache2-mod-rivet (3.2.1-5) unstable; urgency=medium

  * Apply patch from upstream source code repository in order to fix
    memory leak in Rivet_Var (implements ::rivet::var ::rivet::var_qs and
    ::rivet::var_post)

 -- Massimo Manghi <mxmanghi@apache.org>  Mon, 14 Feb 2022 15:57:24 +0100

libapache2-mod-rivet (3.2.1-4) unstable; urgency=medium

  * Make dh_install operate only on libapache2-mod-rivet binary package
    thus excluding libapache2-mod-rivet-doc (Closes: #1003146)
  * Amending former changelog entry erroneously citing a depend on
    the apache2 build scripts that had added and then undone in the
    process of developing the new packaging scripts
  * Restricting dh_auto_configure to architecture depend build
  * Now correctly citing standards version 4.6.0

 -- Massimo Manghi <mxmanghi@apache.org>  Wed, 05 Jan 2022 12:30:30 +0100

libapache2-mod-rivet (3.2.1-3) unstable; urgency=medium

  * Changing debian/rules in order to exploit the Debian sequencer
  * Changing URL in debian/watch after ASF moved to a CDN based distribution
  * Add patches to remove handling of the doc directory. We assume the
    original tar ball is delivering HTML docs that don't need preparation
  * Add patch to selectively copy mod_rivet tcl commands files only
  * Removed trailing whitespace from lines in changelog
  * Explicitly mentioned NMU in last changelog entry, as demanded by lintian
  * Add copyright notice for README.md
  * Remove copyright notice for LICENSE. It's not necessary
  * Update debian/watch version
  * Debian standard compliance checked up to standards version 4.6.0.1

 -- Massimo Manghi <mxmanghi@apache.org>  Sun, 26 Dec 2021 22:42:26 +0100

libapache2-mod-rivet (3.2.1-2) unstable; urgency=medium

  * NMU to unstable - the upload of 3.2.1-1 to stable
    was a mistake.

 -- Sven Hoexter <hoexter@debian.org>  Sun, 14 Nov 2021 13:54:56 +0100

libapache2-mod-rivet (3.2.1-1) stable; urgency=medium

  * New upstream release.
  * New rivet version addresses issue with multiple AM_AUTOMAKE_INIT
    expansion (Closes: #998490).
  * Correcting the name of the target directory where rivet library and
    Tcl scripts are moved into (it still had the old 3.1 version name)

 -- Massimo Manghi <mxmanghi@apache.org>  Sat, 13 Nov 2021 18:35:38 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: httpd
 Priority: optional
 Maintainer: Massimo Manghi <mxmanghi@apache.org>
-Build-Depends: tcl-dev, apache2-dev, libtool, debhelper (>= 11~), automake, dpkg-dev (>= 1.16.1~) 
-Standards-Version: 4.5.0
+Build-Depends: tcl-dev, apache2-dev, libtool, debhelper-compat (= 13), automake
+Rules-Requires-Root: no
+Standards-Version: 4.6.0
 Homepage: http://tcl.apache.org/rivet/
 
 Package: libapache2-mod-rivet
@@ -26,7 +27,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Description: Documentation for Rivet, a server-side Tcl programming system 
+Description: Documentation for Rivet, a server-side Tcl programming system
  Apache Rivet is a system for creating dynamic web content via the Tcl
  programming language integrated with Apache Web Server. It is
  designed to be fast, powerful and extensible, consume few system
@@ -36,4 +37,3 @@
  manipulation, XML, and so on). In order to meet these goals
  Tcl programming language was chosen to combine with the Apache HTTP
  Server. This package contains the HTML configuration and programming manual.
-

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://dlcdn.apache.org/tcl/rivet/rivet-(\d.*)\.tar\.gz

## libapache2-mod-rivet 3.2.2

=== debian/changelog ===
libapache2-mod-rivet (3.2.2-1) unstable; urgency=medium

  * New upstream release
  * Unapplying patch var_get_memory_leak as patch was integrated in this
    release
  * Compliance with Debian policy standards v4.6.1 checked
  * Add copyright reference for various libtool related m4 files that
    weree copied by the recent tcl.m4 upgrade
  * Rephrase the Jan 5th entry in a hopefully more intelligible english

 -- Massimo Manghi <mxmanghi@apache.org>  Thu, 23 Jun 2022 09:37:52 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Massimo Manghi <mxmanghi@apache.org>
 Build-Depends: tcl-dev, apache2-dev, libtool, debhelper-compat (= 13), automake
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: http://tcl.apache.org/rivet/
 
 Package: libapache2-mod-rivet

## libapache2-mod-rivet 3.2.4

=== debian/changelog ===
libapache2-mod-rivet (3.2.4-1) unstable; urgency=medium

  * New upstream release 

 -- Massimo Manghi <mxmanghi@apache.org>  Sun, 18 Feb 2024 12:16:00 +0000

libapache2-mod-rivet (3.2.3-1) unstable; urgency=medium

  * New upstream release
  * Checked compliance to standards version 4.6.2
  * Adding the Forwarded field in the patches that are not meant to be
    forwarded upstream. Reinstating the the DEP-3 structure that was
    somehow removed from 3 of 4 patches

 -- Massimo Manghi <mxmanghi@apache.org>  Thu, 26 Oct 2023 06:46:13 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Massimo Manghi <mxmanghi@apache.org>
 Build-Depends: tcl-dev, apache2-dev, libtool, debhelper-compat (= 13), automake
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: http://tcl.apache.org/rivet/
 
 Package: libapache2-mod-rivet

## libapache2-mod-rivet 3.2.5

=== debian/changelog ===
libapache2-mod-rivet (3.2.5-1) unstable; urgency=medium

  * New upstream release
  * Standards version 4.7.0 compliance
  * Created armored version of the binary keyring as suggested by uscan
  * Update copyright years for rivet sources
  * Removed year from debian/* copyright

 -- Massimo Manghi <mxmanghi@apache.org>  Thu, 23 May 2024 03:02:22 +0000

## libapache2-mod-rivet 3.2.6

=== debian/changelog ===
libapache2-mod-rivet (3.2.6-1) unstable; urgency=medium

  * New upstream release

 -- Massimo Manghi <mxmanghi@apache.org>  Tue, 12 Nov 2024 23:00:26 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Massimo Manghi <mxmanghi@apache.org>
 Build-Depends: tcl-dev, apache2-dev, libtool, debhelper-compat (= 13), automake
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: http://tcl.apache.org/rivet/
 
 Package: libapache2-mod-rivet

## libapache2-mod-rivet 3.2.8

=== debian/changelog ===
libapache2-mod-rivet (3.2.8-1) unstable; urgency=medium

  * Standards version 4.7.2 compliance
  * New upstream release 
  * Build a comprehensive patch for Makefile.am. One of the previous series
    of patches didn't apply anymore

 -- Massimo Manghi <mxmanghi@apache.org>  Sun, 16 Nov 2025 17:52:31 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Massimo Manghi <mxmanghi@apache.org>
 Build-Depends: tcl-dev, apache2-dev, libtool, debhelper-compat (= 13), automake
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: http://tcl.apache.org/rivet/
 
 Package: libapache2-mod-rivet

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

RIVETLIB_DIR=/usr/lib/tcltk/rivet$(shell cut -d '.' -f 1 VERSION)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

%:
	dh $@ --with apache2

override_dh_auto_configure:
	. /usr/lib/tclConfig.sh; \
	dh_auto_configure -a -- --host=$(DEB_HOST_GNU_TYPE)    \
				--build=$(DEB_BUILD_GNU_TYPE)           \
				--with-tcl=/usr/lib/tcl$${TCL_VERSION}  \
				--with-apache=/usr                      \
				--with-apxs=/usr/bin/apxs               \
				--with-rivet-target-dir=$(RIVETLIB_DIR) \
				--enable-version-display
